#include"LinkedList.h"


// are requered for insque and remque
#define __USE_XOPEN_EXTENDED
#define __USE_GNU

#include<search.h>

/**
 * creates a new MNB_ListElement for the item and appends it to the list
 * 
 **/
void MNB_AddToList(void * item, struct MNB_List * list){
    //we can't add something to an nonexisting list
    if(list != NULL){	    
	    list->size = list->size + 1;
	    
	    //creating the new list element
	    struct MNB_ListElement * newElement = malloc(sizeof(struct MNB_ListElement));
		newElement->data = item;
	    
	    //if we have a last element, meaning list isn't empty we can just
		//append the MNB_ListElement
	    if(list->last != NULL){
			insque(newElement, list->last);
		
		} else { //otherwise we have some more work to do
			
			insque(newElement, NULL);
			list->first = newElement;
		}
		//the new one is allways the last one	
		list->last = newElement;
		
	}
}

/**
 * tries to find item in the list and remove its MNB_ListElement
 * 
 * 
 **/
void MNB_RemoveFromList(void *item, struct MNB_List *list){
	if(list->first != NULL){
		// loop to go through all elements of the list
		struct MNB_ListElement * iterator = list->first;
		while(iterator != NULL){
			//if its the one we are looking for
			if(iterator->data == item){
				//move the first and last pointers
				if(iterator == list->first){
					list->first = list->first->next;
				}
				if(iterator == list->last){
					list->last = list->last->prev;
				}
				//remove the element from the list
				remque(iterator);
				
				//and update size
				list->size = list->size - 1;
				
				//set the first and last pointer correct for an empty list
				if(list->size == 0){
					list->first = NULL;
					list->last = NULL;
				}
				break;
			}
			iterator = iterator->next;
		}
	}
}


/**
 * Allocates the memory for a Linked list and sets 
 * default values
 * 
 **/
struct MNB_List * MNB_CreateList(){
    struct MNB_List * list = malloc(sizeof(struct MNB_List));
    list->size = 0;
    list->first = NULL;
    list->last = NULL;
    return list;
}


/**
 * Removes all Elements from the list and frees up the momory used by it
 * 
 **/
void MNB_DeleteList(struct MNB_List * list){
	struct MNB_ListElement * iterator = list->first;
	while(iterator != NULL){
		MNB_RemoveFromList(iterator->data, list);
		iterator = iterator->next;
	}
	free(list);
}

/**
 * Creates a shallow copy of the list, by creating a new list and
 * adding all elements of the original list to it
 * 
 **/
struct MNB_List * MNB_CopyList(struct MNB_List * originalList){
	struct MNB_List * newList = MNB_CreateList(); 
	struct MNB_ListElement * iterator = originalList->first;
	while(iterator != NULL){
		MNB_AddToList(iterator->data, newList);
		iterator = iterator->next;
	}
	return newList;
}

/**
 * creates a new list and adds all elements of both lists to it
 * 
 **/
struct MNB_List * MNB_ConcatList(struct MNB_List * firstList, struct MNB_List * secondList){
	struct MNB_List * newList = MNB_CopyList(firstList);
	
	struct MNB_ListElement * iterator = secondList->first;
	while(iterator != NULL){
		MNB_AddToList(iterator->data, newList);
		iterator = iterator->next;
	}
	return newList;
}

	
