#ifndef LINKEDLIST
#define LINKEDLIST

#include<stdlib.h>
#include<assert.h>

#include<stdio.h>
#include<string.h>

 
 
#ifndef TRUE
#define TRUE 1;
#define FALSE 0;
#endif
 


struct MNB_ListElement {
	struct MNB_ListElement * next;
	struct MNB_ListElement * prev;
	void * data;
};


struct MNB_List {
	int size;   //Number of elements in list
	struct MNB_ListElement * first;
	struct MNB_ListElement * last;
};


/**
 * Allocates the requered memory and sets default values for an empty
 * LinkedList
 * 
 * 
 **/
struct MNB_List * MNB_CreateList();



/**
 * Frees the momory userd for the LinkedList
 * 
 * 
 **/
void MNB_DeleteList(struct MNB_List * list);

/**
 * Appends the pointer at the end of the list
 * 
 * 
 **/
void MNB_AddToList(void *item, struct MNB_List *list);


/**
 * Removes the pointer from the list
 * 
 * 
 **/
void MNB_RemoveFromList(void *item, struct MNB_List * list);

/**
 * creates a shallow copy of the list
 * 
 **/
struct MNB_List * MNB_CopyList(struct MNB_List * originalList);



/**
 * creates a new list containing all elements of both original lists
 * 
 * 
 **/
struct MNB_List * MNB_ConcatList(struct MNB_List * firstList, struct MNB_List * secondList);


#endif


