#include<mpi.h>

//~ #define DEBUG

#include"mnb-configuration.h"
#include"mnb-environment.h"
#include"mnb-execution.h"
#include"mnb-utils.h"




int main(int argc, char ** argv)
{
	MPI_Init(&argc, &argv);
	
	MNB_Environment * env = MNB_CreateEnvironment();
	MNB_ReadEnvironment(env);
	MNB_PrintWelcome(env);
	MNB_println("environment read");
	
	MNB_Configuration * conf = MNB_CreateConfiguration();
	//~ MNB_ReadConfigurationFromFile(conf, "./example.cfg");
	MNB_ReadConfigurationFromFile(conf, argv[1]);
	MNB_println("configuration read");
	
	
	MPI_Barrier(MPI_COMM_WORLD);
	MNB_Execute(conf, env);
	MNB_println("execution complete");
		
	//cleanup before quiting
	MNB_DeleteEnvironment(env);
	MNB_println("env deleted");
	MNB_FreeConfiguration(conf);
	MNB_println("configuration deleted");
	
	
	MPI_Finalize();
	MNB_printf("%s\n", "MPI Finalized");// i can't use my MNB_println since it would try to get the rank
	//while MPI is allready finalized  
	
	
	return 0;
}
