#ifndef MNB_CONFIG
#define MNB_CONFIG



#include"mnb-utils.h"


//some default values for Tests.
#define MNB_DEFAULT_MAX_TEST_DURATION 300
#define MNB_DEFAULT_MIN_TEST_REPEATS 10


/**
 * An MNB_Configuration is the representation of all the information
 * this programm is looking for in an .cfg file.
 * 
 * Mostly it's the list of Tests that requere executen and information
 * about them.
 * 
 **/
typedef struct  {
	FILE * conf_file;
	int minRepeats; //Default values, that can be overridden by tests
	int maxDuration;
	struct MNB_List * tests;
} MNB_Configuration;

/**
 * allocates the requered memory and sets default values for 
 * a configuration
 * 
 **/  
MNB_Configuration * MNB_CreateConfiguration();


/**
 * Tries to fill an MNB_Configuration, with information from the a file.
 * returns 0 on success, -1 on failure;
 * 
 **/
int MNB_ReadConfigurationFromFile(MNB_Configuration * conf, char * filename);




/**
 * frees up all the memory allocated to filling an MNB_Configuration
 *  
 **/
void MNB_FreeConfiguration(MNB_Configuration * conf);



#endif
