#ifndef MNB_ENVIRONMENT
#define MNB_ENVIRONMENT


#include<mpi.h>




enum MNB_NodeStatus { MNB_NODE_BUSY, MNB_NODE_FREE};

typedef struct{
	char * hostname;
	struct MNB_List * ranks;
	enum MNB_NodeStatus status; // busy or free. we can't schedule another test
								// on a busy Host
} MNB_Node;



typedef struct{
	int numberOfNodes;
	int numberOfRanks;
	int schedulerRank;

	MNB_Node * schedulerNode;	//to keep track of the ranks on the schedulerNode
								//besides the schedulerRank
	MNB_Node * localNode;
	struct MNB_List * testerNodes;		//list of nodes that will do the tests
	
	int singleNodeExecution;			//some things have to be done different
										//if we are working on one host only
										//ceeping the information on execution mode
										//makes it easier to implement this workarounds
}MNB_Environment;





MNB_Environment * MNB_CreateEnvironment();

MNB_Environment * MNB_ReadEnvironment(MNB_Environment * env);

MNB_Environment * MNB_CopyEnvironment(MNB_Environment * orig_env);

void MNB_DeleteEnvironment(MNB_Environment * env);





MNB_Node * MNB_CreateNode();

void MNB_DeleteNode(MNB_Node * host);




#endif
